# Date:Feb 12th,2014
import math

Fx=raw_input("enter the name of file Fx: ")
Fy=raw_input("enter the name of file Fy: ")


##read and manipulate values from two files, and form two lists of floats
infile = open(Fx,'r')
Fxstr = infile.read()
infile.close()
Fxlist = Fxstr.split('\n')
Fxlist0 = []
for ele in Fxlist:
    Fxlist0.append(float(ele))
infile = open(Fy,'r')
Fystr = infile.read()
infile.close()
Fylist = Fystr.split('\n')
Fylist0 = []
for eles in Fylist:
    Fylist0.append(float(eles))

    
##calculate the value of average x and average y
n = len(Fxlist0)
sumx=0
sumy=0

for i in range(n):
    sumx += Fxlist0[i]
    sumy += Fylist0[i]

ax = sumx/float(n)
ay = sumy/float(n)

##calculate a,b,c for calculating coefficient--"r"
a,b,c=0,0,0
for i in range(n):
    a += (Fxlist0[i]-ax)*(Fylist0[i]-ay)
    b += (Fxlist0[i]-ax)**2
    c += (Fylist0[i]-ay)**2

r = a/(math.sqrt(b)*math.sqrt(c))


## output Lx, Ly and r
print "Lx=",Fxlist0
print "Ly=",Fylist0
print "r=",r


##Design problem:
##        Yes, I can. The calculation for "r" related to the calculation for three different
##    sums:1. sum((xi-avg_x)*(yi-avg_y),i=0..n-1)
##        2. sum((xi-avg_x)^2,i=0..n-1)
##        3. sum((yi-avg_x)^2,i=0..n-1)
##    I can use one for loop to calculate the three different sums at the same time.
##    For example: a,b,c=0,0,0
##                 for i in range(n):
##                    a += (Fxlist0[i]-ax)*(Fylist0[i]-ay)
##                    b += (Fxlist0[i]-ax)**2
##                    c += (Fylist0[i]-ay)**2
##                 r = a/(math.sqrt(b)*math.sqrt(c))
             

##Test plan:
##
##Test: i
##Input: [[1.0, 2.0, 3.0, 42.0, 23.0, 1.0, 3.3],[4.5, 6.7, 2.0, 3.0, 1.0, 2.0, 3.0]]
##Expected Output: -0.298238058989
##Test Output: -0.298238058989
##Result: Pass
##
##Test: ii
##Input:  [[1e+47, 2.0, 3.0, 4.0, 22.0, 1.0, 3.93298392],[4.5, 6.7, 2.0, 3.0, 1.0, 2232321321.0, 3.2132137862178367]]
##Expected Output:  -0.166666666093
##Test Output:  -0.166666666093
##Result: Pass
##
##Test: iii
##Input:  [[1e+47, 2.0, 3*'cat', 4.0, 22.0, 1.0, 3.93298392],[4.5, 6.7, 2.0, 3.0, 1.0, 2232321321.0, 3.2132137862178367]]
##Expected Output: error
##Test Output: error
##Reason: literal with type "string" and contains some characters cannot be transferred into a float number
##Result: Pass
