# Spencer Smith
# macid: smiths
# student number: #######
# February 08, 2011
#
# This is a solution for Lab 05: Marked Assignment 2 on Thursday.

import string
import math

def main():

    print """\

This program is a solution to lab 05: Marked Assignment 2 on Thursday.
"""

    # Read input files into lists of strings
    inputFileName = raw_input("Enter the name of the input file of x values: ")
    Fx = open(inputFileName, "r")
    x = string.split(Fx.read())
    Fx.close()

    inputFileName = raw_input("Enter the name of the input file of y values: ")
    Fy = open(inputFileName, "r")
    y = string.split(Fy.read())
    Fy.close()

    n = len(x)

    # Convert strings to floats
    for i in range(n):
        x[i] = float(x[i])
        y[i] = float(y[i])

    # Compute means
    xbar = 0.0
    ybar = 0.0
    for i in range(n):
        xbar = xbar + x[i]
        ybar = ybar + y[i]
    xbar = xbar/n
    ybar = ybar/n
    
    # Compute r
    sxy = 0.0
    sxsq = 0.0
    sysq = 0.0
    for i in range(n):
        sxy = sxy + (x[i]-xbar)*(y[i]-ybar)
        sxsq = sxsq + (x[i]-xbar)**2
        sysq = sysq + (y[i]-ybar)**2
    a = sxy
    b = math.sqrt(sxsq)
    c = math.sqrt(sysq)
    r = a/(b*c)

    # Print output
    print ""
    print "The input list Lx of floats is= ", x
    print ""
    print "The input list Ly of floats is= ", y
    print ""
    print "The value of the product moment correlation coefficient r is= ", r
    print ""

main()

# Design Question
# 
# No, one cannot solve for r with one loop.  The
# formula to calculate r which involves a loop for
# summations, depends on xbar and ybar and the
# calculation of these values requires a separate pass
# through the data values.
#
# Testing Question
# 
# Test: 1
# Input:    Lx = [0.0, 0.1, 0.2, 0.3, 0.4]
#           Ly = [1.0, 1.1, 1.2, 1.3, 1.4]
# Expected Output: 1.0
#
#
# Test: 2
# Input:    Lx = [1, 2, 3, 4, 5]
#           Ly = [-1, -2, -3, -4, -5]
# Expected Output: -1.0
#
#
# Test: 3
# Input:    Invalid File Name
# Expected Output: IOError
