# Mar 19th, 2014 
from graphics import *
from math import *
def distanceBetweenPoints(p1,p2):
  return sqrt((p1.getX()-p2.getX())**2+(p1.getY()-p2.getY())**2)
  
def drawCircle(w,c,r,s):

  C = Circle(c,r)
  C.draw(w)
  C.setFill(s)
  return C

def circleGame():
  win = GraphWin('simple GUI',500,500)
  win.setCoords(0,0,100,100)
  C = drawCircle(win,Point(50,50),40,'red')
  flag = 1
  while flag:
    click = win.getMouse()
    rad = C.getRadius()

    if (distanceBetweenPoints(click,Point(50,50)) <= 0.25*rad):
      win.close()
      flag = 0
    elif (distanceBetweenPoints(click,Point(50,50)) >= 0.25*rad) and (distanceBetweenPoints(click,Point(50,50)) <= rad):
      C.undraw()
      rad = rad*0.8
      C = drawCircle(win,Point(50,50),rad,'red')
    else:
      C.undraw()
      rad = rad*1.1
      C = drawCircle(win,Point(50,50),rad,'red')
    
#Test: Pass

#yeah using if
#Yes
#No  circle is a local object
